<script lang="ts">
  import { getToastStore } from '@skeletonlabs/skeleton';
  import { completeDaily, dailies, refreshDailies, type Daily } from './tasks';
    import { addTreasure, dieRoll } from './wealth';

  const toast = getToastStore();
  const refresh = () => {
    refreshDailies();
    toast.trigger({ message: 'Daily Task list reset!' });
  };
  const finish = (daily: Daily) => {
    completeDaily(daily);
    const earned = dieRoll(daily.value)
    addTreasure(daily.currency, earned);
    toast.trigger({ message: `<em>${daily.task}</em> marked as done until the next new day. Earned ${earned} ${daily.currency}`});
  }
</script>

<section class="card my-3 p-2 pt-0 variant-ghost-secondary">
  <header class="card-header text-lg text-center font-bold">Daily Tasks</header>
  <article class="grid gap-2">
    {#each $dailies as daily}
      <button
        type="button"
        class="chip text-lg variant-soft"
        disabled={!!daily.completed}
        on:click={() => finish(daily)}
      >
        {daily.task}
        {#if daily.completed}
          <span class="badge text-xxs bg-ghost dark:bg-black ms-1">
            {new Date(daily.completed).toLocaleString()}
          </span>
        {/if}
      </button>
    {/each}
  </article>
  <footer class="card-footer flex justify-around">
    <button type="button" class="btn variant-filled-surface mx-auto" on:click={refresh}>
      Start new Day
    </button>
  </footer>
</section>

<style>
    .text-xxs {
        font-size: xx-small;
    }
</style>